unit mouse;
interface
uses dos,unute1,prsystem,crt;

const
  curpos=1;
  leftpress=2;
  leftrel=4;
  rightpress=8;
  rightrel=16;
var
  mouse_reg:registers;
  mouse_installed:boolean;
  mouse_error:word;

function initmouse:word;
procedure showmouse;
procedure hidemouse;
procedure showm;
procedure hidem;
function mouseposition(var mousex,mousey:word):word;
procedure setmouseposition(mousex,mousey:word);
function mousepress(button:word;
                    var count,lastx,lasty:word):word;
procedure setmousexy(x1,y1,x2,y2:word);
procedure setpixeltomickey(horiz,verti:word);

implementation

procedure setpixeltomickey(horiz,verti:word);
begin
with mouse_reg do begin
ax:=15;
cx:=horiz;
dx:=verti;
end;
intr($33,mouse_reg);
end;


function initmouse:word;
begin
  with mouse_reg do
     ax:=0;
   intr($33,mouse_reg);
   initmouse:=mouse_reg.ax;
   end;

procedure showmouse;
begin
  mouse_reg.ax:=1;
  intr($33,mouse_reg);
end;

procedure hidemouse;
begin
  mouse_reg.ax:=2;
  intr($33,mouse_reg);
end;

procedure showm;
begin
  mouse_reg.ax:=1;
  intr($33,mouse_reg);
end;

procedure hidem;
begin
  mouse_reg.ax:=2;
  intr($33,mouse_reg);
end;

procedure mp(var mousex,mousey:word);
begin
  mouse_reg.ax:=3;
  intr($33,mouse_reg);
  with mouse_reg do begin
    mousex:=succ(cx div 8);
    mousey:=succ(dx div 8);
  end;
end;

function mouseposition(var mousex,mousey:word):word;
var sonx,sony,x,y:word;crt1:pointer;
begin
  mouse_reg.ax:=3;
  intr($33,mouse_reg);
  with mouse_reg do
  begin
    mousex:=succ(cx div 8);
    mousey:=succ(dx div 8);
    mouseposition:=bx;
  end;

{    mp(x,y);
    if (x<>sonx) or (y<>sony) then
    begin
      hidem;getscreen(crt1);
      delay(1500);
      savescreen(crt1);
      showm;sonx:=x;sony:=y;
    end;}
end;


procedure setmouseposition(mousex,mousey:word);
begin
mouse_reg.ax:=4;
mouse_reg.cx:=pred(mousex*8);
mouse_reg.dx:=pred(mousey*8);
intr($33,mouse_reg);
end;

function mousepress(button:word;var count,lastx,lasty:word):word;
begin
mouse_reg.ax:=5;
mouse_reg.bx:=button;
intr($33,mouse_reg);
mousepress:=mouse_reg.ax;
count:=mouse_reg.bx;
lastx:=succ(mouse_reg.cx div 8);
lasty:=succ(mouse_reg.dx div 8);
end;

procedure setmousexy(x1,y1,x2,y2:word);
begin
mouse_reg.ax:=7;
mouse_reg.cx:=pred(x1*8);
mouse_reg.dx:=pred(x2*8);
intr($33,mouse_reg);
mouse_reg.ax:=8;
mouse_reg.cx:=pred(y1*8);
mouse_reg.dx:=pred(y2*8);
intr($33,mouse_reg);
end;
end.